//  Rectangle.cc - a rectangle.
//
//	Vamos Automotive Simulator
//  Copyright (C) 2005 Sam Varner
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

#include "Rectangle.h"

#include <algorithm>

using namespace Vamos_Geometry;

Rectangle::Rectangle (double left_in, double top_in, 
                      double right_in, double bottom_in)
  : left (left_in),
    top (top_in),
    right (right_in),
    bottom (bottom_in)
{
}

// Enlarge the rectangle if necessary so that another rectangle is
// completely enclosed.
const Rectangle&
Rectangle::enclose (const Rectangle& other)
{
  left = std::min (left, other.left);
  top = std::max (top, other.top);
  right = std::max (right, other.right);
  bottom = std::min (bottom, other.bottom);
  return *this;
}

std::ostream& Vamos_Geometry::
operator << (std::ostream& os, const Rectangle& rectangle)
{
  os << "(" << rectangle.left << ", " << rectangle.top
	 << ") (" << rectangle.right << ", " << rectangle.bottom << ")";
  return os;
}
